from Products.CMFCore.utils import getToolByName
from Products.Archetypes.Extensions.utils import install_subskin
from StringIO import StringIO
from Products.BatchIt.config import *

def install_resources(self, out):
    """ Install the kss resource """
    
    csstool = getToolByName(self, 'portal_css')
    for kss in KSS:
        csstool.manage_addStylesheet(id = kss,
            rel = 'kukit',
            rendering = 'link',
            enabled = True,
            cookable = False,
            )
    print >> out, "Registered kss resources."
    
def install_views(self, out):
    """ Install views """
    
    portal_types = getToolByName(self, 'portal_types')
    folder = getattr(portal_types, 'Folder')
    views = folder.getAvailableViewMethods(None)
    if 'batch_table_view' not in views:
        folder.manage_changeProperties(view_methods = ['batch_table_view'] + list(views))
        print >> out, "Added batch table view to folder type."
    topic = getattr(portal_types, 'Topic')
    views = topic.getAvailableViewMethods(None)
    if 'batch_topic_view' not in views:
        topic.manage_changeProperties(view_methods = ['batch_topic_view'] + list(views))
        print >> out, "Added batch topic view to topic type."
    
def unregister_js(self, out):
    """ Unregister the table sorter javascript """
    
    portal_js = getToolByName(self, 'portal_javascripts')
    if 'table_sorter.js' in portal_js.getResourceIds():
        portal_js.manage_removeScript(id = 'table_sorter.js')
        print >> out, "Removed the table sorter javascript."

def install(self):
    """ The global install """
    
    out = StringIO()
    install_subskin(self, out, GLOBALS)
    print >> out, "Installed subskin."
    
    install_resources(self, out)
    install_views(self, out)
    unregister_js(self, out)
    
    print >> out, "Successfully installed %s." % PROJECTNAME
    return out.getvalue()
