from Products.PloneAzax import AzaxBaseView
from Products.azax.plugins.core.interfaces import IKSSCoreCommands
from Products.azax import force_unicode
from Products.CMFPlone import Batch
from Acquisition import aq_inner

class BatchView(AzaxBaseView):
    """ Base view class to enable kss-based batch sorting
    """

    def getBatch(self):
        """ Create the batch to display the navigator """
        
        session = self.request.SESSION
        if session.has_key('batch'):
            b = session['batch']
            return Batch(b['sequence'], b['size'], b['start'])
        
    def replaceNavigator(self):
        """ Replace the batch navigator with the ajaxified one if javascript is enabled """
        
        html = self.macroContent('batch_navigation/macros/navigation')
        
        html = force_unicode(html, 'utf')
        IKSSCoreCommands(self).replaceHTML(
           IKSSCoreCommands(self).getCssSelector('div.listingBar'), html)
        
        return self.render()
    
    def clearSessionObject(self):
        """ Clear the session object (not yet supported) """
        
        session = self.request.SESSION
        if session.has_key('batch'):
            del session['batch']
        
    def browseBatch(self, start):
        """ Browse the navigator """
        
        session = self.request.SESSION
        if session.has_key('batch'):
            b = session['batch']
            self._constructTable(int(start), b['size'], b['sequence'])
        
        html = self.macroContent('batch_navigation/macros/navigation')
        
        html = force_unicode(html, 'utf')
        IKSSCoreCommands(self).replaceHTML(
           IKSSCoreCommands(self).getCssSelector('div.listingBar'), html)
        
        return self.render()
    
    def _reorderArrows(self, field, sort_id, sort_query):
        """ Helper method to reorder the sort arrows """
        
        context = aq_inner(self.context)
        url = context.portal_url()
        
        src_url = force_unicode(url + '/arrowBlank.gif', 'utf')
        IKSSCoreCommands(self).setAttribute(
           IKSSCoreCommands(self).getCssSelector('thead th img'), 'src', src_url)
        
        if sort_query == 'asc':
            url += '/arrowUp.gif'
        elif sort_query == 'desc':
            url += '/arrowDown.gif'
        html = """<img src="%s"
                       id="%s-%s"
                       height="6"
                       width="9"/>""" \
                   % (url,
                      field,
                      sort_query)

        html = force_unicode(html, 'utf')
        IKSSCoreCommands(self).replaceHTML(
           IKSSCoreCommands(self).getHtmlIdSelector(field + '-' + sort_id), html)
        
        sort_query = force_unicode(sort_query, 'utf')
        IKSSCoreCommands(self).setAttribute(
           IKSSCoreCommands(self).getHtmlIdSelector(field), 'sort', sort_query)
        
    def _constructTable(self, start, size, sequence, sort = None):
        """ Helper method to recreate the sorted table, implemented by derived view classes """
        
        pass
